{$mode objfpc}{$H-}{$R+}{$T+}{$Q+}{$V+}{$D+}{$X-}{$warnings on}
program busqueda_real_02;
    // Búsqueda de un real, versión mejorada.
    // Si lo encontramos, dejamos de buscar.

const
    TamanioVector = 4;
type
    TipoVector = array[1..TamanioVector] of real;

function busca_valor(vector: TipoVector; valor, margen: real): integer;
    // Esta función busca un valor en el array, permitiendo
    // cierto margen. Devuelve su posición en el vector. Si no existe, devuelve 0
var
    i: integer;
    sal: boolean;  // Cuando sea cierto, salgo del bucle
begin
    result := 0;
    i := 1;
    sal := FALSE;
    repeat
        if abs(vector[i] - valor) <= margen then begin
            result := i;
            sal := TRUE
        end;
        if i= TamanioVector then
            sal := TRUE
        else
            i := i+1
    until sal    
end;

const
    Tiempos_prueba: TipoVector = (93.0, 87.4, 0, 86.2);
    Tiempo_a_buscar: real = 95;
    Margen: real = 0.6;
begin
    writeln(busca_valor(Tiempos_prueba, Tiempo_a_buscar, Margen))
end.

