{$mode objfpc}{$H-}{$R+}{$T+}{$Q+}{$V+}{$D+}{$X-}{$warnings on}
program todos_en_margen;
// Queremos saber si todos los valores de un vector cumplen
// la condición de estar en el intervalo definido por un
// valor de referencia +- cierto margen

const
    TamanioVector = 4;
type
    TipoVector = array[1..TamanioVector] of real;

function comprueba_margen(
    vector: TipoVector; referencia, margen: real): boolean;
    // Esta función comprueba si todos los vector están dentro 
    // de un valor promedio, más menos cierto margen
var
    i: integer;
    sal: boolean;  // Cuando sea cierto, salgo del bucle
begin
    result := TRUE; // De momento supongo que todos cumplen
    i := 1;
    sal := FALSE;   // De momento indico que no acabe el bucle
    repeat
        if abs(vector[i] - referencia) > margen then begin
            // Valor fuera del intervalo
            result := False;
            sal := TRUE
        end;
        if i= TamanioVector then
            sal := TRUE
        else
            i := i+1
    until sal;   
end;

const
    Margen: real = 5 ;
    Vector_prueba_1 : TipoVector = (115.4, 110.9, 111.9, 114.1);
    Vector_prueba_2 : TipoVector = (115.4, 124.2, 111.9, 120.7);
var
    valor_referencia : real = 113.0;
begin
    writeln(comprueba_margen(
        Vector_prueba_1, valor_referencia, Margen));  // TRUE

    writeln(comprueba_margen(
        Vector_prueba_2, valor_referencia, Margen))  // FALSE
end.

